package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.DocumentosDescargar;
import com.ejie.ab79.model.REST.servicioWeb.DocumentoActividadAsociada;
import com.ejie.ab79.model.REST.servicioWeb.DocumentoExpRelacionado;
import com.ejie.ab79.model.REST.servicioWeb.DocumentoExpediente;
import com.ejie.ab79.model.REST.servicioWeb.DocumentoFicha;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DocumentosDescargarDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class DocumentosDescargarDaoImpl implements DocumentosDescargarDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDDOCUMENTODESCARGAR", "IDINSPECCION", "OID",
			"ORIGENOID", "DESCRIPCIONTIPOCASTELLANO", "DESCRIPCIONTIPOEUSKERA", "NOMBREDOCUMENTO", "TITULODOCUMENTO",
			"FECHAAPORTADO", "ORIGENDOCUMENTACION", "FOLDERNUMBER", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<DocumentosDescargar> rwMap = new RowMapper<DocumentosDescargar>() {
		public DocumentosDescargar mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			return new DocumentosDescargar(resultSet.getInt("IDDOCUMENTODESCARGAR"), inspeccion,
					resultSet.getString("OID"), resultSet.getInt("ORIGENOID"),
					resultSet.getString("DESCRIPCIONTIPOCASTELLANO"), resultSet.getString("DESCRIPCIONTIPOEUSKERA"),
					resultSet.getString("NOMBREDOCUMENTO"), resultSet.getString("TITULODOCUMENTO"),
					resultSet.getDate("FECHAAPORTADO"), resultSet.getInt("ORIGENDOCUMENTACION"),
					resultSet.getString("FOLDERNUMBER"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<DocumentosDescargar> rwMapPK = new RowMapper<DocumentosDescargar>() {
		public DocumentosDescargar mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new DocumentosDescargar(resultSet.getInt("ID_DOCUMENTO_DESCARGAR"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<DocumentosDescargar>> rwMapJerarquia = new RowMapper<JerarquiaDto<DocumentosDescargar>>() {
		public JerarquiaDto<DocumentosDescargar> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			DocumentosDescargar documentosdescargar = new DocumentosDescargar(
					resultSet.getInt("ID_DOCUMENTO_DESCARGAR"), inspeccion, resultSet.getString("OID"),
					resultSet.getInt("ORIGEN_OID"), resultSet.getString("DESCRIPCION_TIPO_CASTELLANO"),
					resultSet.getString("DESCRIPCION_TIPO_EUSKERA"), resultSet.getString("NOMBRE_DOCUMENTO"),
					resultSet.getString("TITULO_DOCUMENTO"), resultSet.getDate("FECHA_APORTADO"),
					resultSet.getInt("ORIGEN_DOCUMENTACION"), resultSet.getString("FOLDER_NUMBER"),
					resultSet.getDate("FECHA_REGISTRO"), resultSet.getString("USUARIO_REGISTRO"));

			JerarquiaDto<DocumentosDescargar> jerarquia = new JerarquiaDto<DocumentosDescargar>();
			jerarquia.setModel(documentosdescargar);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<DocumentoFicha> rwMapDocumentoFichaREST = new RowMapper<DocumentoFicha>() {
		public DocumentoFicha mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentoFicha documentoFicha = new DocumentoFicha();
			documentoFicha.setIdDocumento(resultSet.getInt("iddocumento"));
			documentoFicha.setIdActuacion(resultSet.getInt("idactuacion"));
			documentoFicha.setOid(resultSet.getString("oid"));
			documentoFicha.setOrigenOid(resultSet.getInt("origenoid"));
			documentoFicha.setNombreDocumento(resultSet.getString("nombredocumento"));
			documentoFicha.setIdTipoPlantilla(resultSet.getInt("idtipoplantilla"));
			documentoFicha.setDescripcionTipoCastellano(resultSet.getString("descripcionTipoCastellano"));
			documentoFicha.setDescripcionTipoEuskera(resultSet.getString("descripcionTipoEuskera"));

			return documentoFicha;
		}
	};

	private RowMapper<DocumentoExpediente> rwMapDocumentoExpedienteREST = new RowMapper<DocumentoExpediente>() {
		public DocumentoExpediente mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentoExpediente documentoExpediente = new DocumentoExpediente();
			documentoExpediente.setIdDocumento(resultSet.getInt("iddocumento"));
			documentoExpediente.setNumExpediente(resultSet.getString("numexpediente"));
			documentoExpediente.setDescripcion(resultSet.getString("descripcion"));
			documentoExpediente.setOid(resultSet.getString("oid"));
			documentoExpediente.setNombreDocumento(resultSet.getString("nombredocumento"));
			documentoExpediente.setFecha(resultSet.getDate("fecha"));

			return documentoExpediente;
		}
	};

	private RowMapper<DocumentoExpRelacionado> rwMapDocumentoExpRelacionadoREST = new RowMapper<DocumentoExpRelacionado>() {
		public DocumentoExpRelacionado mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentoExpRelacionado documentoExpRelacionado = new DocumentoExpRelacionado();
			documentoExpRelacionado.setIdDocumento(resultSet.getInt("iddocumento"));
			documentoExpRelacionado.setNumExpediente(resultSet.getString("numexpediente"));
			documentoExpRelacionado.setDescripcion(resultSet.getString("descripcion"));
			documentoExpRelacionado.setOid(resultSet.getString("oid"));
			documentoExpRelacionado.setNombreDocumento(resultSet.getString("nombredocumento"));
			documentoExpRelacionado.setFecha(resultSet.getDate("fecha"));

			return documentoExpRelacionado;
		}
	};

	private RowMapper<DocumentoActividadAsociada> rwMapDocumentoActividadAsociadaREST = new RowMapper<DocumentoActividadAsociada>() {
		public DocumentoActividadAsociada mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DocumentoActividadAsociada documentoActividadAsociada = new DocumentoActividadAsociada();
			documentoActividadAsociada.setIdDocumento(resultSet.getInt("iddocumento"));
			documentoActividadAsociada.setOid(resultSet.getString("oid"));
			documentoActividadAsociada.setNombreDocumento(resultSet.getString("nombredocumento"));
			documentoActividadAsociada.setTipoCastellano(resultSet.getString("tipocastellano"));
			documentoActividadAsociada.setTipoEuskera(resultSet.getString("tipoeuskera"));
			documentoActividadAsociada.setFecha(resultSet.getDate("fecha"));

			return documentoActividadAsociada;
		}
	};

	private RowMapper<DocumentosDescargar> rwMapEnviados = new RowMapper<DocumentosDescargar>() {
		public DocumentosDescargar mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			DocumentosDescargar documentoDescargar = new DocumentosDescargar();
			documentoDescargar.setOid(resultSet.getString("OID"));

			return documentoDescargar;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the DocumentosDescargar table.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @return DocumentosDescargar
	 */
	public DocumentosDescargar add(DocumentosDescargar documentosdescargar) {

		documentosdescargar.setIdDocumentoDescargar(
				this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7933T00.NEXTVAL FROM DUAL", Integer.class));

		String query = "INSERT INTO DOCUMENTOS_DESCARGAR (ID_DOCUMENTO_DESCARGAR, ID_INSPECCION, OID, ORIGEN_OID, DESCRIPCION_TIPO_CASTELLANO, DESCRIPCION_TIPO_EUSKERA, NOMBRE_DOCUMENTO, TITULO_DOCUMENTO, FECHA_APORTADO, ORIGEN_DOCUMENTACION, FOLDER_NUMBER, ID_ACTUACION, ID_TIPO_PLANTILLA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,sysdate,?)";
		this.jdbcTemplate.update(query, documentosdescargar.getIdDocumentoDescargar(),
				documentosdescargar.getInspeccion().getIdInspeccion(), documentosdescargar.getOid(),
				documentosdescargar.getOrigenOid(), documentosdescargar.getDescripcionTipoCastellano(),
				documentosdescargar.getDescripcionTipoEuskera(), documentosdescargar.getNombreDocumento(),
				documentosdescargar.getTituloDocumento(), documentosdescargar.getFechaAportado(),
				documentosdescargar.getOrigenDocumentacion(), documentosdescargar.getFolderNumber(),
				documentosdescargar.getIdActuacion(), documentosdescargar.getIdTipoPlantilla(),
				documentosdescargar.getUsuarioRegistro());
		return documentosdescargar;
	}

	/**
	 * Updates a single row in the DocumentosDescargar table.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @return DocumentosDescargar
	 */
	public DocumentosDescargar update(DocumentosDescargar documentosdescargar) {
		String query = "UPDATE DOCUMENTOS_DESCARGAR SET ID_INSPECCION=?, OID=?, ORIGEN_OID=?, DESCRIPCION_TIPO_CASTELLANO=?, DESCRIPCION_TIPO_EUSKERA=?, NOMBRE_DOCUMENTO=?, TITULO_DOCUMENTO=?, FECHA_APORTADO=?, ORIGEN_DOCUMENTACION=?, FOLDER_NUMBER=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=? WHERE ID_DOCUMENTO_DESCARGAR=?";
		this.jdbcTemplate.update(query, documentosdescargar.getInspeccion().getIdInspeccion(),
				documentosdescargar.getOid(), documentosdescargar.getOrigenOid(),
				documentosdescargar.getDescripcionTipoCastellano(), documentosdescargar.getDescripcionTipoEuskera(),
				documentosdescargar.getNombreDocumento(), documentosdescargar.getTituloDocumento(),
				documentosdescargar.getFechaAportado(), documentosdescargar.getOrigenDocumentacion(),
				documentosdescargar.getFolderNumber(), documentosdescargar.getFechaRegistro(),
				documentosdescargar.getUsuarioRegistro(), documentosdescargar.getIdDocumentoDescargar());
		return documentosdescargar;
	}

	/**
	 * Finds a single row in the DocumentosDescargar table.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @return DocumentosDescargar
	 */
	@Transactional(readOnly = true)
	public DocumentosDescargar find(DocumentosDescargar documentosdescargar) {
		String query = "SELECT t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR, t1.ID_INSPECCION IDINSPECCION, t1.OID OID, t1.ORIGEN_OID ORIGENOID, t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO, t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA, t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO, t1.TITULO_DOCUMENTO TITULODOCUMENTO, t1.FECHA_APORTADO FECHAAPORTADO, t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION, t1.FOLDER_NUMBER FOLDERNUMBER, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM DOCUMENTOS_DESCARGAR t1  WHERE t1.ID_DOCUMENTO_DESCARGAR = ?  ";

		List<DocumentosDescargar> documentosdescargarList = this.jdbcTemplate.query(query, this.rwMap,
				documentosdescargar.getIdDocumentoDescargar());
		return (DocumentosDescargar) DataAccessUtils.uniqueResult(documentosdescargarList);
	}

	@Override
	public List<DocumentosDescargar> obtenerEnviados(Integer idInspeccion, Integer origenDocumentacion) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.OID FROM DOCUMENTOS_DESCARGAR t1 WHERE t1.ID_INSPECCION = ? AND t1.ORIGEN_DOCUMENTACION = ? ");

		return (List<DocumentosDescargar>) this.jdbcTemplate.query(query.toString(), this.rwMapEnviados, idInspeccion,
				origenDocumentacion);
	}

	@Override
	public List<DocumentosDescargar> obtenerEnviadosExpRel(Integer idInspeccion) {
		String query = "SELECT t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR, t1.ID_INSPECCION IDINSPECCION, t1.OID OID, t1.ORIGEN_OID ORIGENOID, t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO, t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA, t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO, t1.TITULO_DOCUMENTO TITULODOCUMENTO, t1.FECHA_APORTADO FECHAAPORTADO, t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION, t1.FOLDER_NUMBER FOLDERNUMBER, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM DOCUMENTOS_DESCARGAR t1 WHERE t1.ID_INSPECCION = ? AND t1.ORIGEN_DOCUMENTACION = ?  ";

		return (List<DocumentosDescargar>) this.jdbcTemplate.query(query, this.rwMap, idInspeccion,
				Constantes.DocumentosDescargar.ORIGEN_EXP_RELACIONADO);
	}

	/**
	 * Removes a single row in the DocumentosDescargar table.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @return
	 */
	public void remove(DocumentosDescargar documentosdescargar) {
		String query = "DELETE FROM DOCUMENTOS_DESCARGAR WHERE ID_DOCUMENTO_DESCARGAR=?";
		this.jdbcTemplate.update(query, documentosdescargar.getIdDocumentoDescargar());
	}

	@Override
	public void removeByIdInspeccion(int idInspeccion) {
		String query = "DELETE FROM DOCUMENTOS_DESCARGAR WHERE ID_INSPECCION=?";
		this.jdbcTemplate.update(query, idInspeccion);
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<DocumentosDescargar> getMultiple(DocumentosDescargar filterDocumentosDescargar,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterDocumentosDescargar, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, DocumentosDescargar.class,
				params, "ID_DOCUMENTO_DESCARGAR");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the DocumentosDescargar table.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<DocumentosDescargar>
	 */
	@Transactional(readOnly = true)
	public List<DocumentosDescargar> findAll(DocumentosDescargar documentosdescargar, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR,t1.ID_INSPECCION IDINSPECCION,t1.OID OID,t1.ORIGEN_OID ORIGENOID,t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO,t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.TITULO_DOCUMENTO TITULODOCUMENTO,t1.FECHA_APORTADO FECHAAPORTADO,t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION,t1.FOLDER_NUMBER FOLDERNUMBER,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM DOCUMENTOS_DESCARGAR t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(documentosdescargar);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DocumentosDescargarDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<DocumentosDescargar>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the DocumentosDescargar table using like.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DocumentosDescargar>
	 */
	@Transactional(readOnly = true)
	public List<DocumentosDescargar> findAllLike(DocumentosDescargar documentosdescargar,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR,t1.ID_INSPECCION IDINSPECCION,t1.OID OID,t1.ORIGEN_OID ORIGENOID,t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO,t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.TITULO_DOCUMENTO TITULODOCUMENTO,t1.FECHA_APORTADO FECHAAPORTADO,t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION,t1.FOLDER_NUMBER FOLDERNUMBER,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM DOCUMENTOS_DESCARGAR t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(documentosdescargar, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DocumentosDescargarDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<DocumentosDescargar>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<DocumentoFicha> findDocumentoFichaREST(Integer idInspeccion) {
		String query = "SELECT t1.id_documento_descargar iddocumento, t1.id_actuacion idactuacion, t1.oid oid, t1.origen_oid origenoid, t1.nombre_documento nombredocumento, t1.descripcion_tipo_castellano descripcionTipoCastellano, t1.descripcion_tipo_euskera descripcionTipoEuskera, t1.id_tipo_plantilla idtipoplantilla FROM documentos_descargar t1 WHERE t1.id_inspeccion = ? and t1.origen_documentacion = "
				+ Constantes.DocumentosDescargar.ORIGEN_FICHA_INSPECCION;

		return (List<DocumentoFicha>) this.jdbcTemplate.query(query, this.rwMapDocumentoFichaREST, idInspeccion);
	}

	@Override
	public List<DocumentoExpediente> findDocumentoExpedienteREST(Integer idInspeccion) {
		String query = "SELECT t1.id_documento_descargar iddocumento, t1.folder_number numexpediente, t1.titulo_documento descripcion, t1.oid oid, t1.nombre_documento nombredocumento, t1.fecha_aportado fecha FROM documentos_descargar t1 WHERE t1.origen_documentacion = "
				+ Constantes.DocumentosDescargar.ORIGEN_EXPEDIENTE + " AND t1.id_inspeccion = ?";

		return (List<DocumentoExpediente>) this.jdbcTemplate.query(query, this.rwMapDocumentoExpedienteREST,
				idInspeccion);
	}

	@Override
	public List<DocumentoExpRelacionado> findDocumentoExpRelacionadoREST(Integer idInspeccion) {
		String query = "SELECT t1.id_documento_descargar iddocumento, t1.folder_number numexpediente, t1.titulo_documento descripcion, t1.oid oid, t1.nombre_documento nombredocumento, t1.fecha_aportado fecha FROM documentos_descargar t1 WHERE t1.origen_documentacion = "
				+ Constantes.DocumentosDescargar.ORIGEN_EXP_RELACIONADO + " AND t1.id_inspeccion = ?";

		return (List<DocumentoExpRelacionado>) this.jdbcTemplate.query(query, this.rwMapDocumentoExpRelacionadoREST,
				idInspeccion);
	}

	@Override
	public List<DocumentoActividadAsociada> findDocumentoActividadAsociadaREST(Integer idInspeccion) {
		String query = "SELECT t1.id_documento_descargar iddocumento, t1.oid oid, t1.nombre_documento nombredocumento, t1.descripcion_tipo_castellano tipocastellano, t1.descripcion_tipo_euskera tipoeuskera, t1.fecha_aportado fecha FROM documentos_descargar t1 WHERE t1.origen_documentacion = "
				+ Constantes.DocumentosDescargar.ORIGEN_ACTIVIDAD + " AND t1.id_inspeccion = ?";

		return (List<DocumentoActividadAsociada>) this.jdbcTemplate.query(query,
				this.rwMapDocumentoActividadAsociadaREST, idInspeccion);
	}

	@Override
	public String findNombreByOid(String oid) {
		String query = "SELECT NOMBRE_DOCUMENTO FROM DOCUMENTOS_DESCARGAR WHERE OID = ?";

		List<DocumentosDescargar> docsDesc = this.jdbcTemplate.query(query, new RowMapper<DocumentosDescargar>() {
			public DocumentosDescargar mapRow(ResultSet resultSet, int rowNum) throws SQLException {

				DocumentosDescargar documentoDescargar = new DocumentosDescargar();
				documentoDescargar.setNombreDocumento(resultSet.getString("NOMBRE_DOCUMENTO"));
				return documentoDescargar;
			}
		}, oid);

		DocumentosDescargar docDesc = (DocumentosDescargar) DataAccessUtils.uniqueResult(docsDesc);
		return docDesc.getNombreDocumento();
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the DocumentosDescargar table.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(DocumentosDescargar documentosdescargar) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM DOCUMENTOS_DESCARGAR t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(documentosdescargar);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the DocumentosDescargar table using like.
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(DocumentosDescargar documentosdescargar, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM DOCUMENTOS_DESCARGAR t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(documentosdescargar, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of DocumentosDescargar selected for rup_table
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DocumentosDescargar>>
	 */
	@Override
	public List<TableRowDto<DocumentosDescargar>> reorderSelection(DocumentosDescargar documentosdescargar,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR,t1.ID_INSPECCION IDINSPECCION,t1.OID OID,t1.ORIGEN_OID ORIGENOID,t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO,t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.TITULO_DOCUMENTO TITULODOCUMENTO,t1.FECHA_APORTADO FECHAAPORTADO,t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION,t1.FOLDER_NUMBER FOLDERNUMBER,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM DOCUMENTOS_DESCARGAR t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(documentosdescargar, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				DocumentosDescargar.class, filterParamList, "ID_DOCUMENTO_DESCARGAR");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<DocumentosDescargar>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            DocumentosDescargar
	 * @param searchParams
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DocumentosDescargar>>
	 */
	@Override
	public List<TableRowDto<DocumentosDescargar>> search(DocumentosDescargar filterParams,
			DocumentosDescargar searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR,t1.ID_INSPECCION IDINSPECCION,t1.OID OID,t1.ORIGEN_OID ORIGENOID,t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO,t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.TITULO_DOCUMENTO TITULODOCUMENTO,t1.FECHA_APORTADO FECHAAPORTADO,t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION,t1.FOLDER_NUMBER FOLDERNUMBER,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM DOCUMENTOS_DESCARGAR t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				DocumentosDescargar.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_DOCUMENTO_DESCARGAR");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<DocumentosDescargar>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterdocumentosdescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(DocumentosDescargar filterdocumentosdescargar, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR,t1.ID_INSPECCION IDINSPECCION,t1.OID OID,t1.ORIGEN_OID ORIGENOID,t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO,t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.TITULO_DOCUMENTO TITULODOCUMENTO,t1.FECHA_APORTADO FECHAAPORTADO,t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION,t1.FOLDER_NUMBER FOLDERNUMBER,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM DOCUMENTOS_DESCARGAR t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterdocumentosdescargar, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				DocumentosDescargar.class, query, params, "ID_DOCUMENTO_DESCARGAR");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical DocumentosDescargar table.
	 *
	 * @param filterDocumentosDescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<DocumentosDescargar>>
	 */
	@Override
	public List<JerarquiaDto<DocumentosDescargar>> findAllLikeJerarquia(DocumentosDescargar filterDocumentosDescargar,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO_DESCARGAR IDDOCUMENTODESCARGAR,t1.ID_INSPECCION IDINSPECCION,t1.OID OID,t1.ORIGEN_OID ORIGENOID,t1.DESCRIPCION_TIPO_CASTELLANO DESCRIPCIONTIPOCASTELLANO,t1.DESCRIPCION_TIPO_EUSKERA DESCRIPCIONTIPOEUSKERA,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.TITULO_DOCUMENTO TITULODOCUMENTO,t1.FECHA_APORTADO FECHAAPORTADO,t1.ORIGEN_DOCUMENTACION ORIGENDOCUMENTACION,t1.FOLDER_NUMBER FOLDERNUMBER,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM DOCUMENTOS_DESCARGAR t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DOCUMENTOS_DESCARGAR");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDocumentosDescargar, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_DOCUMENTO_DESCARGAR", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					DocumentosDescargarDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterDocumentosDescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(DocumentosDescargar filterDocumentosDescargar,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM DOCUMENTOS_DESCARGAR t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DOCUMENTOS_DESCARGAR");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDocumentosDescargar, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_DOCUMENTO_DESCARGAR",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterDocumentosDescargar
	 *            DocumentosDescargar
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<DocumentosDescargar>>
	 */
	@Override
	public List<TableRowDto<DocumentosDescargar>> findAllChild(DocumentosDescargar filterDocumentosDescargar,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM DOCUMENTOS_DESCARGAR t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DOCUMENTOS_DESCARGAR");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDocumentosDescargar, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
				"ID_DOCUMENTO_DESCARGAR", "ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<DocumentosDescargar>(this.rwMapPK, "ID_DOCUMENTO_DESCARGAR"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the DocumentosDescargar entity
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(DocumentosDescargar documentosdescargar) {

		StringBuilder where = new StringBuilder(DocumentosDescargarDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (documentosdescargar != null && documentosdescargar.getIdDocumentoDescargar() != null) {
			where.append(" AND t1.ID_DOCUMENTO_DESCARGAR = ?");
			params.add(documentosdescargar.getIdDocumentoDescargar());
		}
		if (documentosdescargar != null && documentosdescargar.getInspeccion() != null
				&& documentosdescargar.getInspeccion().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(documentosdescargar.getInspeccion().getIdInspeccion());
		}
		if (documentosdescargar != null && documentosdescargar.getOid() != null) {
			where.append(" AND t1.OID = ?");
			params.add(documentosdescargar.getOid());
		}
		if (documentosdescargar != null && documentosdescargar.getOrigenOid() != null) {
			where.append(" AND t1.ORIGEN_OID = ?");
			params.add(documentosdescargar.getOrigenOid());
		}
		if (documentosdescargar != null && documentosdescargar.getDescripcionTipoCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_TIPO_CASTELLANO = ?");
			params.add(documentosdescargar.getDescripcionTipoCastellano());
		}
		if (documentosdescargar != null && documentosdescargar.getDescripcionTipoEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_TIPO_EUSKERA = ?");
			params.add(documentosdescargar.getDescripcionTipoEuskera());
		}
		if (documentosdescargar != null && documentosdescargar.getNombreDocumento() != null) {
			where.append(" AND t1.NOMBRE_DOCUMENTO = ?");
			params.add(documentosdescargar.getNombreDocumento());
		}
		if (documentosdescargar != null && documentosdescargar.getTituloDocumento() != null) {
			where.append(" AND t1.TITULO_DOCUMENTO = ?");
			params.add(documentosdescargar.getTituloDocumento());
		}
		if (documentosdescargar != null && documentosdescargar.getFechaAportado() != null) {
			where.append(" AND t1.FECHA_APORTADO = ?");
			params.add(documentosdescargar.getFechaAportado());
		}
		if (documentosdescargar != null && documentosdescargar.getOrigenDocumentacion() != null) {
			where.append(" AND t1.ORIGEN_DOCUMENTACION = ?");
			params.add(documentosdescargar.getOrigenDocumentacion());
		}
		if (documentosdescargar != null && documentosdescargar.getFolderNumber() != null) {
			where.append(" AND t1.FOLDER_NUMBER = ?");
			params.add(documentosdescargar.getFolderNumber());
		}
		if (documentosdescargar != null && documentosdescargar.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(documentosdescargar.getFechaRegistro());
		}
		if (documentosdescargar != null && documentosdescargar.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(documentosdescargar.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the DocumentosDescargar entity
	 *
	 * @param documentosdescargar
	 *            DocumentosDescargar Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(DocumentosDescargar documentosdescargar, Boolean startsWith) {

		StringBuilder where = new StringBuilder(DocumentosDescargarDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (documentosdescargar != null && documentosdescargar.getIdDocumentoDescargar() != null) {
			where.append(" AND t1.ID_DOCUMENTO_DESCARGAR = ?");
			params.add(documentosdescargar.getIdDocumentoDescargar());
		}
		if (documentosdescargar != null && documentosdescargar.getInspeccion() != null
				&& documentosdescargar.getInspeccion().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(documentosdescargar.getInspeccion().getIdInspeccion());
		}
		if (documentosdescargar != null && documentosdescargar.getOid() != null) {
			where.append(" AND UPPER(t1.OID) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getOid().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getOid().toUpperCase() + "%");
			}
			where.append(" AND t1.OID IS NOT NULL");
		}
		if (documentosdescargar != null && documentosdescargar.getOrigenOid() != null) {
			where.append(" AND t1.ORIGEN_OID = ?");
			params.add(documentosdescargar.getOrigenOid());
		}
		if (documentosdescargar != null && documentosdescargar.getDescripcionTipoCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_TIPO_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getDescripcionTipoCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getDescripcionTipoCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_TIPO_CASTELLANO IS NOT NULL");
		}
		if (documentosdescargar != null && documentosdescargar.getDescripcionTipoEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_TIPO_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getDescripcionTipoEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getDescripcionTipoEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_TIPO_EUSKERA IS NOT NULL");
		}
		if (documentosdescargar != null && documentosdescargar.getNombreDocumento() != null) {
			where.append(" AND UPPER(t1.NOMBRE_DOCUMENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getNombreDocumento().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getNombreDocumento().toUpperCase() + "%");
			}
			where.append(" AND t1.NOMBRE_DOCUMENTO IS NOT NULL");
		}
		if (documentosdescargar != null && documentosdescargar.getTituloDocumento() != null) {
			where.append(" AND UPPER(t1.TITULO_DOCUMENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getTituloDocumento().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getTituloDocumento().toUpperCase() + "%");
			}
			where.append(" AND t1.TITULO_DOCUMENTO IS NOT NULL");
		}
		if (documentosdescargar != null && documentosdescargar.getFechaAportado() != null) {
			where.append(" AND t1.FECHA_APORTADO = ?");
			params.add(documentosdescargar.getFechaAportado());
		}
		if (documentosdescargar != null && documentosdescargar.getOrigenDocumentacion() != null) {
			where.append(" AND t1.ORIGEN_DOCUMENTACION = ?");
			params.add(documentosdescargar.getOrigenDocumentacion());
		}
		if (documentosdescargar != null && documentosdescargar.getFolderNumber() != null) {
			where.append(" AND UPPER(t1.FOLDER_NUMBER) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getFolderNumber().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getFolderNumber().toUpperCase() + "%");
			}
			where.append(" AND t1.FOLDER_NUMBER IS NOT NULL");
		}
		if (documentosdescargar != null && documentosdescargar.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(documentosdescargar.getFechaRegistro());
		}
		if (documentosdescargar != null && documentosdescargar.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(documentosdescargar.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + documentosdescargar.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
